Index: /trunk/kBuild/sdks/MACOSX120.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX120.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX120.kmk	(revision 3602)
@@ -0,0 +1,66 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v12.0 SDK.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1201  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX120 := Mac OS X v12.0 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX120
+ PATH_SDK_MACOSX120 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX12.0.sdk)
+ ifndef PATH_SDK_MACOSX120
+  PATH_SDK_MACOSX120 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX12.sdk)
+ endif
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX120 := $(PATH_SDK_MACOSX120)
+endif
+ifeq ($(PATH_SDK_MACOSX120),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX12.0.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and -mmacosx-version-min values for this SDK.
+SDK_MACOSX120_VERSION_ARG   := 12.0
+SDK_MACOSX120_VERSION_VALUE := $(subst .,,$(SDK_MACOSX120_VERSION_VALUE))000
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX120_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=$(SDK_MACOSX120_VERSION_VALUE)
+SDK_MACOSX120_CFLAGS      ?= -mmacosx-version-min=$(SDK_MACOSX120_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX120)"
+SDK_MACOSX120_CXXFLAGS    ?= -mmacosx-version-min=$(SDK_MACOSX120_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX120)"
+SDK_MACOSX120_OBJCFLAGS   ?= -mmacosx-version-min=$(SDK_MACOSX120_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX120)"
+SDK_MACOSX120_OBJCXXFLAGS ?= -mmacosx-version-min=$(SDK_MACOSX120_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX120)"
+SDK_MACOSX120_LDFLAGS     ?= -mmacosx-version-min=$(SDK_MACOSX120_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX120)"
+
Index: /trunk/kBuild/sdks/MACOSX120INCS.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX120INCS.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX120INCS.kmk	(revision 3602)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v12.0 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1201  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX120
+ include $(KBUILD_PATH)/sdks/MACOSX120.kmk
+endif
+
+SDK_MACOSX120INCS := Mac OS X v12.0 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX120INCS
+ PATH_SDK_MACOSX120INCS := $(PATH_SDK_MACOSX120)
+else
+ PATH_SDK_MACOSX120INCS := $(PATH_SDK_MACOSX120INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX120INCS_INCS = $(PATH_SDK_MACOSX120INCS)/usr/include
+
Index: /trunk/kBuild/sdks/MACOSX130.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX130.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX130.kmk	(revision 3602)
@@ -0,0 +1,66 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v13.0 SDK.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX130 := Mac OS X v13.0 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX130
+ PATH_SDK_MACOSX130 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX13.0.sdk)
+ ifndef PATH_SDK_MACOSX130
+  PATH_SDK_MACOSX130 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX13.sdk)
+ endif
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX130 := $(PATH_SDK_MACOSX130)
+endif
+ifeq ($(PATH_SDK_MACOSX130),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX13.0.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and -mmacosx-version-min values for this SDK.
+SDK_MACOSX130_VERSION_ARG   := 13.0
+SDK_MACOSX130_VERSION_VALUE := $(subst .,,$(SDK_MACOSX130_VERSION_VALUE))000
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX130_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=$(SDK_MACOSX130_VERSION_VALUE)
+SDK_MACOSX130_CFLAGS      ?= -mmacosx-version-min=$(SDK_MACOSX130_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX130)"
+SDK_MACOSX130_CXXFLAGS    ?= -mmacosx-version-min=$(SDK_MACOSX130_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX130)"
+SDK_MACOSX130_OBJCFLAGS   ?= -mmacosx-version-min=$(SDK_MACOSX130_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX130)"
+SDK_MACOSX130_OBJCXXFLAGS ?= -mmacosx-version-min=$(SDK_MACOSX130_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX130)"
+SDK_MACOSX130_LDFLAGS     ?= -mmacosx-version-min=$(SDK_MACOSX130_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX130)"
+
Index: /trunk/kBuild/sdks/MACOSX130INCS.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX130INCS.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX130INCS.kmk	(revision 3602)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v13.0 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX130
+ include $(KBUILD_PATH)/sdks/MACOSX130.kmk
+endif
+
+SDK_MACOSX130INCS := Mac OS X v13.0 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX130INCS
+ PATH_SDK_MACOSX130INCS := $(PATH_SDK_MACOSX130)
+else
+ PATH_SDK_MACOSX130INCS := $(PATH_SDK_MACOSX130INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX130INCS_INCS = $(PATH_SDK_MACOSX130INCS)/usr/include
+
Index: /trunk/kBuild/sdks/MACOSX133.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX133.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX133.kmk	(revision 3602)
@@ -0,0 +1,63 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v13.3 SDK.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX133 := Mac OS X v13.3 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX133
+ PATH_SDK_MACOSX133 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX13.3.sdk)
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX133 := $(PATH_SDK_MACOSX133)
+endif
+ifeq ($(PATH_SDK_MACOSX133),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX13.3.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and -mmacosx-version-min values for this SDK.
+SDK_MACOSX133_VERSION_ARG   := 13.3
+SDK_MACOSX133_VERSION_VALUE := $(subst .,,$(SDK_MACOSX130_VERSION_VALUE))000
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX133_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=$(SDK_MACOSX133_VERSION_VALUE)
+SDK_MACOSX133_CFLAGS      ?= -mmacosx-version-min=$(SDK_MACOSX133_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX133)"
+SDK_MACOSX133_CXXFLAGS    ?= -mmacosx-version-min=$(SDK_MACOSX133_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX133)"
+SDK_MACOSX133_OBJCFLAGS   ?= -mmacosx-version-min=$(SDK_MACOSX133_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX133)"
+SDK_MACOSX133_OBJCXXFLAGS ?= -mmacosx-version-min=$(SDK_MACOSX133_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX133)"
+SDK_MACOSX133_LDFLAGS     ?= -mmacosx-version-min=$(SDK_MACOSX133_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX133)"
+
Index: /trunk/kBuild/sdks/MACOSX133INCS.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX133INCS.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX133INCS.kmk	(revision 3602)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v13.3 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX133
+ include $(KBUILD_PATH)/sdks/MACOSX133.kmk
+endif
+
+SDK_MACOSX133INCS := Mac OS X v13.3 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX133INCS
+ PATH_SDK_MACOSX133INCS := $(PATH_SDK_MACOSX133)
+else
+ PATH_SDK_MACOSX133INCS := $(PATH_SDK_MACOSX133INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX133INCS_INCS = $(PATH_SDK_MACOSX133INCS)/usr/include
+
Index: /trunk/kBuild/sdks/MACOSX140.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX140.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX140.kmk	(revision 3602)
@@ -0,0 +1,66 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v14.0 SDK.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1401  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX140 := Mac OS X v14.0 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX140
+ PATH_SDK_MACOSX140 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX14.0.sdk)
+ ifndef PATH_SDK_MACOSX140
+  PATH_SDK_MACOSX140 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX14.sdk)
+ endif
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX140 := $(PATH_SDK_MACOSX140)
+endif
+ifeq ($(PATH_SDK_MACOSX140),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX14.0.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and -mmacosx-version-min values for this SDK.
+SDK_MACOSX140_VERSION_ARG   := 14.0
+SDK_MACOSX140_VERSION_VALUE := $(subst .,,$(SDK_MACOSX140_VERSION_VALUE))000
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX140_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=$(SDK_MACOSX140_VERSION_VALUE)
+SDK_MACOSX140_CFLAGS      ?= -mmacosx-version-min=$(SDK_MACOSX140_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX140)"
+SDK_MACOSX140_CXXFLAGS    ?= -mmacosx-version-min=$(SDK_MACOSX140_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX140)"
+SDK_MACOSX140_OBJCFLAGS   ?= -mmacosx-version-min=$(SDK_MACOSX140_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX140)"
+SDK_MACOSX140_OBJCXXFLAGS ?= -mmacosx-version-min=$(SDK_MACOSX140_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX140)"
+SDK_MACOSX140_LDFLAGS     ?= -mmacosx-version-min=$(SDK_MACOSX140_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX140)"
+
Index: /trunk/kBuild/sdks/MACOSX140INCS.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX140INCS.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX140INCS.kmk	(revision 3602)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v14.0 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1401  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX140
+ include $(KBUILD_PATH)/sdks/MACOSX140.kmk
+endif
+
+SDK_MACOSX140INCS := Mac OS X v14.0 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX140INCS
+ PATH_SDK_MACOSX140INCS := $(PATH_SDK_MACOSX140)
+else
+ PATH_SDK_MACOSX140INCS := $(PATH_SDK_MACOSX140INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX140INCS_INCS = $(PATH_SDK_MACOSX140INCS)/usr/include
+
Index: /trunk/kBuild/sdks/MACOSX150.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX150.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX150.kmk	(revision 3602)
@@ -0,0 +1,66 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v15.0 SDK.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1501  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX150 := Mac OS X v15.0 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX150
+ PATH_SDK_MACOSX150 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX15.0.sdk)
+ ifndef PATH_SDK_MACOSX150
+  PATH_SDK_MACOSX150 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX15.sdk)
+ endif
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX150 := $(PATH_SDK_MACOSX150)
+endif
+ifeq ($(PATH_SDK_MACOSX150),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX15.0.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and -mmacosx-version-min values for this SDK.
+SDK_MACOSX150_VERSION_ARG   := 15.0
+SDK_MACOSX150_VERSION_VALUE := $(subst .,,$(SDK_MACOSX150_VERSION_VALUE))000
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX150_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=$(SDK_MACOSX150_VERSION_VALUE)
+SDK_MACOSX150_CFLAGS      ?= -mmacosx-version-min=$(SDK_MACOSX150_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX150)"
+SDK_MACOSX150_CXXFLAGS    ?= -mmacosx-version-min=$(SDK_MACOSX150_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX150)"
+SDK_MACOSX150_OBJCFLAGS   ?= -mmacosx-version-min=$(SDK_MACOSX150_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX150)"
+SDK_MACOSX150_OBJCXXFLAGS ?= -mmacosx-version-min=$(SDK_MACOSX150_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX150)"
+SDK_MACOSX150_LDFLAGS     ?= -mmacosx-version-min=$(SDK_MACOSX150_VERSION_ARG) -isysroot "$(PATH_SDK_MACOSX150)"
+
Index: /trunk/kBuild/sdks/MACOSX150INCS.kmk
===================================================================
--- /trunk/kBuild/sdks/MACOSX150INCS.kmk	(revision 3602)
+++ /trunk/kBuild/sdks/MACOSX150INCS.kmk	(revision 3602)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v15.0 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2024 knut st. osmundsen <bird-kBuild-spam-xxiii@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1501  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX150
+ include $(KBUILD_PATH)/sdks/MACOSX150.kmk
+endif
+
+SDK_MACOSX150INCS := Mac OS X v15.0 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX150INCS
+ PATH_SDK_MACOSX150INCS := $(PATH_SDK_MACOSX150)
+else
+ PATH_SDK_MACOSX150INCS := $(PATH_SDK_MACOSX150INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX150INCS_INCS = $(PATH_SDK_MACOSX150INCS)/usr/include
+