Index: /trunk/kStuff/kHlp/CRT/kHlpCRTAlloc.cpp
===================================================================
--- /trunk/kStuff/kHlp/CRT/kHlpCRTAlloc.cpp	(revision 3606)
+++ /trunk/kStuff/kHlp/CRT/kHlpCRTAlloc.cpp	(revision 3607)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
@@ -14,4 +14,10 @@
  * version 2.1 of the License, or (at your option) any later version.
  *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
+ *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -21,6 +27,6 @@
  * You should have received a copy of the GNU Lesser General Public
  * License along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
- *
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
 
Index: /trunk/kStuff/kHlp/CRT/kHlpCRTEnv.cpp
===================================================================
--- /trunk/kStuff/kHlp/CRT/kHlpCRTEnv.cpp	(revision 3606)
+++ /trunk/kStuff/kHlp/CRT/kHlpCRTEnv.cpp	(revision 3607)
@@ -1,9 +1,9 @@
 /* $Id$ */
 /** @file
- * kHlpCRT - Environment Manipulation.
+ * kHlpEnv - Environment Manipulation.
  */
 
 /*
- * Copyright (c) 2006-2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
@@ -14,4 +14,10 @@
  * version 2.1 of the License, or (at your option) any later version.
  *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
+ *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -21,6 +27,6 @@
  * You should have received a copy of the GNU Lesser General Public
  * License along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
- *
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
 
Index: /trunk/kStuff/kHlp/CRT/kHlpCRTString.cpp
===================================================================
--- /trunk/kStuff/kHlp/CRT/kHlpCRTString.cpp	(revision 3606)
+++ /trunk/kStuff/kHlp/CRT/kHlpCRTString.cpp	(revision 3607)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
@@ -14,4 +14,10 @@
  * version 2.1 of the License, or (at your option) any later version.
  *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
+ *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -21,6 +27,6 @@
  * You should have received a copy of the GNU Lesser General Public
  * License along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
- *
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
 