Index: trunk/kStuff/kRdr/kRdr.cpp
===================================================================
--- trunk/kStuff/kRdr/kRdr.cpp	(revision 3610)
+++ trunk/kStuff/kRdr/kRdr.cpp	(revision 3611)
@@ -5,22 +5,28 @@
 
 /*
- * Copyright (c) 2006-2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
  *
- * kStuff is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * kStuff is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
  *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with kStuff; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
 
Index: trunk/kStuff/kRdr/kRdrBuffered.cpp
===================================================================
--- trunk/kStuff/kRdr/kRdrBuffered.cpp	(revision 3610)
+++ trunk/kStuff/kRdr/kRdrBuffered.cpp	(revision 3611)
@@ -5,22 +5,28 @@
 
 /*
- * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
  *
- * kStuff is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * kStuff is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
  *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with kStuff; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
 
Index: trunk/kStuff/kRdr/kRdrFile.cpp
===================================================================
--- trunk/kStuff/kRdr/kRdrFile.cpp	(revision 3610)
+++ trunk/kStuff/kRdr/kRdrFile.cpp	(revision 3611)
@@ -5,24 +5,29 @@
 
 /*
- * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
  *
- * kStuff is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * kStuff is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
  *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public License
- * along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with kStuff; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
-
 
 /*******************************************************************************
Index: trunk/kStuff/kRdr/kRdrInternal.h
===================================================================
--- trunk/kStuff/kRdr/kRdrInternal.h	(revision 3610)
+++ trunk/kStuff/kRdr/kRdrInternal.h	(revision 3611)
@@ -5,22 +5,28 @@
 
 /*
- * Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+ * Copyright (c) 2006-2007 knut st. osmundsen <bird-kStuff-spam@anduin.net>
  *
  * This file is part of kStuff.
  *
- * kStuff is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
+ * kStuff is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * In addition to the permissions in the GNU Lesser General Public
+ * License, you are granted unlimited permission to link the compiled
+ * version of this file into combinations with other programs, and to
+ * distribute those combinations without any restriction coming from
+ * the use of this file.
  *
  * kStuff is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public License
- * along with kStuff; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with kStuff; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA
  */
 